using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using SimpleJSON;

namespace Cotyounoyume
{
    public class WorldUIAddon1{
		public EBATCore core;
		public WorldUI worldUi;
		public AddonManager1 addonManager1;
		
		public AddonClothSimItem addonClothSim;
		public AddonTakeControlItem addonTakeControl;		
		
		public string strUndressOverall    = "Undress Overall";
		public string strAltSkinWrap       = "Alt Skin Wrap";
		public string strUndressRecover    = "Reset";
		public string strUndressRemove     = "Remove Clothes";

		public string strUndressOutfit    = "Outfit";
		public string strUndressUnderwear = "Underwear";
		public string strUndressMisc      = "Misc";
		
		public UIDynamicButton uiUndressOverall;
		public UIDynamicButton uiUndress;
		public UIDynamicButton uiUndressOutfit;
		public UIDynamicButton uiUndressUnderwear;
		public UIDynamicButton uiUndressMisc;
		public UIDynamicButton uiUndressRecover;
		public UIDynamicButton uiAltSkinWrap;
		public UIDynamicButton uiUndressRemove;
		
		public string strUndressOpt1On     = "Opt1(NG Words) [ON]";
		public string strUndressOpt2On     = "Opt2(ClothSims)[ON]";
		public string strUndressOpt3On     = "Opt3(SkinWraps)[ON]";
		public string strUndressOpt4On     = "SkinWrapToClothSim[ON]";
		public string strUndressOpt5On     = "Undress Forced[ON]";
		public string strUndressOpt6On     = "Reverse Gravity[ON]";
		public string strUndressOpt7On     = "Undress Detach[ON]";
		public string strUndressOpt1Off    = "Opt1(NG Words) [  ]";
		public string strUndressOpt2Off    = "Opt2(ClothSims)[  ]";
		public string strUndressOpt3Off    = "Opt3(SkinWraps)[  ]";
		public string strUndressOpt4Off    = "SkinWrapToClothSim[  ]";
		public string strUndressOpt5Off     = "Undress Forced[  ]";
		public string strUndressOpt6Off    = "Reverse Gravity[  ]";
		public string strUndressOpt7Off    = "Undress Detach[  ]";
		public string strUndressOpt1Var;
		public string strUndressOpt2Var;
		public string strUndressOpt3Var;
		public string strUndressOpt4Var;
		public string strUndressOpt5Var;
		public string strUndressOpt6Var;
		public string strUndressOpt7Var;
		public UIDynamicButton uiUndressOpt1;
		public UIDynamicButton uiUndressOpt2;
		public UIDynamicButton uiUndressOpt3;
		public UIDynamicButton uiUndressOpt4;
		public UIDynamicButton uiUndressOpt5;
		public UIDynamicButton uiUndressOpt6;
		public UIDynamicButton uiUndressOpt7;
		
		public string strHint12   = "Help for Undress...";
		public string strHint13   = "Help for Partial...";
		
		public string strExposeBreasts     = "Expose Breasts";
		public string strExposeBreastsStrong     = "Tear Off Shirt";
		public string strPullUpSkirt       = "Pull up a Skirt";
		public string strRemoveGameObjects = "Stop";
		
		public string strExpandAddon1      = "Addon1[▶]";
		public string strExpandAddon1Alt   = "Addon1[◀]";
		
		public string strTakeControlOfPlugin   = "Stop Other Plugins";
		public string strTakeControlHint   = "This button allows you to temporarily disable the timeline and other animation plugins.";
		public string strHint1   = "Help for stop other...";
		public string strReturnControlOfPlugin = "Restart";

		public float buttonSizeX3 = 800f;

		public UIDynamicButton uiExposeBreasts;
		public UIDynamicButton uiExposeBreastsStrong;
		public UIDynamicButton uiPullUpSkirt;
		public UIDynamicButton uiRemoveGameObjects;
		
		public UIDynamicButton uiTakeControlOfPlugin;
		public UIDynamicTextField uiTakeControlHint;
		public UIDynamicButton uiReturnControlOfPlugin;
		public UIDynamicButton uiHint1;
		public UIDynamicButton uiHint12;
		public UIDynamicButton uiHint13;

		public UIDynamicButton uiExpandAddon1;
		public bool expandAddon1 = true;
		
		public string strTakeControlOfExpression = "Take Control Of Expression";
		public string strStopControlOfExpression = "Stop";
		public UIDynamicButton uiTakeControlOfExpression;
		public UIDynamicButton uiStopControlOfExpression;


		public WorldUIAddon1(WorldUI worldUi){
			this.worldUi = worldUi;
			this.core = worldUi.core;
		}

		public void LoadSettings(){
			this.addonManager1 = core.addonManager1;
			this.addonClothSim         = addonManager1.addonClothSim;
			this.addonTakeControl      = core.addonTakeControl;			
		}
		
		public void ApplySettings(){
			
		}

		public void RemoveMenuBodyAddon(){
			try{
				
			UIDynamicButton[] buttons = {
				uiUndress, uiAltSkinWrap, uiUndressRecover, uiUndressRemove, 
				uiUndressOverall, uiUndressOutfit, uiUndressUnderwear, uiUndressMisc,
				uiExposeBreasts, uiExposeBreastsStrong, uiPullUpSkirt, uiRemoveGameObjects,
				uiExpandAddon1, uiUndressOpt1, uiUndressOpt2, uiUndressOpt3, uiUndressOpt4, uiUndressOpt5, uiUndressOpt6, uiUndressOpt7, 
				uiTakeControlOfPlugin, uiReturnControlOfPlugin, uiHint1, uiHint12, uiHint13,
			};
			var buttons2 = buttons.Concat(uiActionButtons.Values).ToArray();

			UIDynamicSlider[] sliders = {
			};

			UIDynamicTextField[] texts = {
			};
			worldUi.worldUIBase.RemoveMenuBodyImpl(buttons2, sliders, texts);
			
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		

		public void MakeMenuBodyPartExpandButton(string type){
			if(type == "Addon1"){
				uiExpandAddon1 = MakeButton(strExpandAddon1, -1, worldUi.line);
				uiExpandAddon1.button.onClick.AddListener(OnExpandAddon1);
			}
			worldUi.line++;
		}
		
		public void MakeMenuBodyPartCollapseButton(string type){
			if(type == "Addon1"){
				uiExpandAddon1 = MakeButton(strExpandAddon1Alt, -1, worldUi.line);
				uiExpandAddon1.button.onClick.AddListener(OnCollapseAddon1);
			}
			
			worldUi.line++;
		}
		
		public void MakeMenuBodyAddon(){
			if(core.GetMemoryBool("Addon1")){
				MakeMenuBodyPartCollapseButton("Addon1");
				MakeMenuBodyPartAddon1();
			}else{
				if(!core.GetMemoryBool("isCompact")){
					MakeMenuBodyPartExpandButton("Addon1");
				}
			}
			
			UIDynamicButton[] expandButtons = {
				uiExpandAddon1,
			};
			worldUi.ColoringButton(expandButtons, 235f/255f, 161f/255f, 52f/255f);			
		}

		public Dictionary<string, Action> actions = new Dictionary<string, Action>();
		public Dictionary<string, UIDynamicButton> uiActionButtons = new Dictionary<string, UIDynamicButton>();

		public List<string> parts = new List<string>(){
			"hat",	"mask",	"glasses",	"accessory",	"jewely",	"gloves",	"stockings",
			"bra",	"shirt",	"sweater",	"top",	"dress",	"bodysuit",	"underwear",
			"panties",	"skirt",	"pants",	"bottom",	"shorts",	"socks",	"shoes",
		};

		public void MakeMenuBodyPartAddon1UndressPartial(){
			var xindexts = new List<float>(){
				worldUi.quick1, worldUi.quick2, worldUi.quick3, worldUi.quick4, worldUi.quick5, worldUi.quick6, worldUi.quick7 
			};

			actions = new Dictionary<string, Action>();
			int num = 0;
			foreach(var part in parts){
				actions.Add(part, () => { UndressPartialCommon(part);});
				UIDynamicButton uiButton = MakeButton(part, xindexts[num % 7], worldUi.line + (int)(num/7), worldUi.buttonSizeXQuick);
				if(uiActionButtons.ContainsKey(part)) uiActionButtons[part] = uiButton;
				else uiActionButtons.Add(part, uiButton);
				uiActionButtons[part].button.onClick.AddListener(() => actions[part]());
				num++;
			}
			worldUi.line+= 3;
		}

		public void MakeMenuBodyPartAddon1(){
			MakeMenuBodyPartAddon1Undress();
			MakeMenuBodyPartAddon1Remove();
			MakeMenuBodyPartAddon1AlterWrap();
			MakeMenuBodyPartAddon1GrabSphere();
			MakeMenuBodyPartAddon1TakeControl();
		}

		public void MakeMenuBodyPartAddon1Undress(){

			// uiInstantStrengthLow    = MakeButton(strInstantStrengthLow,    quick4, line, width:buttonSizeXQuick, height:sliderSizeY);
			uiUndressRecover = MakeButton(strUndressRecover, -1, worldUi.line+6, height:worldUi.buttonSizeY7);
			uiUndressOverall = MakeButton(strUndressOverall, 0, worldUi.line);
			uiUndressOpt7   = MakeButton(strUndressOpt7Var, 1, worldUi.line);
			uiUndressOpt5   = MakeButton(strUndressOpt5Var, 2, worldUi.line);
			uiUndressOpt6   = MakeButton(strUndressOpt6Var, 3, worldUi.line);
			worldUi.ColoringButton(uiUndressOpt5, 198f/255f, 250f/255f, 192f/255f);
			worldUi.ColoringButton(uiUndressOpt6, 198f/255f, 250f/255f, 192f/255f);
			worldUi.ColoringButton(uiUndressOpt7, 198f/255f, 250f/255f, 192f/255f);
			worldUi.line++;

			uiUndressOutfit = MakeButton(strUndressOutfit, 0, worldUi.line);
			uiUndressUnderwear = MakeButton(strUndressUnderwear, 1, worldUi.line);
			uiUndressMisc = MakeButton(strUndressMisc, 2, worldUi.line);
			if(!core.GetMemoryBool("isCompact")){
				uiHint13        = MakeButton(strHint13, 3, worldUi.line);
				worldUi.ColoringButton(uiHint13, 0f, 0f, 0f);
			}
			worldUi.line++;

			uiUndressRecover.button.onClick.AddListener(OnUndressRecoverClick);
			uiUndressOverall.button.onClick.AddListener(OnUndressOverallClick);
			uiUndressOpt5.button.onClick.AddListener(OnUndressOpt5Click);
			uiUndressOpt6.button.onClick.AddListener(OnUndressOpt6Click);

			uiUndressOpt7.button.onClick.AddListener(OnUndressOpt7Click);
			uiUndressOutfit.button.onClick.AddListener(OnUndressOutfitClick);
			uiUndressUnderwear.button.onClick.AddListener(OnUndressUnderwearClick);
			uiUndressMisc.button.onClick.AddListener(OnUndressMiscClick);
			if(!core.GetMemoryBool("isCompact")){
				uiHint13.button.onClick.AddListener(OnHint13Click);
			}
			MakeMenuBodyPartAddon1UndressPartial();
		}

		public void MakeMenuBodyPartAddon1Remove(){
			uiUndressRemove = MakeButton(strUndressRemove, 0, worldUi.line);
			uiUndressOpt1   = MakeButton(strUndressOpt1Var, 1, worldUi.line);
			uiUndressOpt2   = MakeButton(strUndressOpt2Var, 2, worldUi.line);
			uiUndressOpt3   = MakeButton(strUndressOpt3Var, 3, worldUi.line);
			worldUi.line++;
			
			worldUi.ColoringButton(uiUndressOpt1, 198f/255f, 250f/255f, 192f/255f);
			worldUi.ColoringButton(uiUndressOpt2, 198f/255f, 250f/255f, 192f/255f);
			worldUi.ColoringButton(uiUndressOpt3, 198f/255f, 250f/255f, 192f/255f);

			uiUndressRemove.button.onClick.AddListener(OnUndressRemoveClick);
			uiUndressOpt1.button.onClick.AddListener(OnUndressOpt1Click);
			uiUndressOpt2.button.onClick.AddListener(OnUndressOpt2Click);
			uiUndressOpt3.button.onClick.AddListener(OnUndressOpt3Click);
		}

		public void MakeMenuBodyPartAddon1AlterWrap(){
			uiAltSkinWrap   = MakeButton(strAltSkinWrap, 0, worldUi.line);
			uiUndressOpt4   = MakeButton(strUndressOpt4Var, 1, worldUi.line);
			worldUi.ColoringButton(uiUndressOpt4, 198f/255f, 250f/255f, 192f/255f);
			
			if(!core.GetMemoryBool("isCompact")){
				uiHint12        = MakeButton(strHint12, 2, worldUi.line);
				worldUi.ColoringButton(uiHint12, 0f, 0f, 0f);
			}
			uiAltSkinWrap.button.onClick.AddListener(OnAltSkinWrapClick);
			uiUndressOpt4.button.onClick.AddListener(OnUndressOpt4Click);
			worldUi.line++;
		}

		public void MakeMenuBodyPartAddon1GrabSphere(){
			uiRemoveGameObjects = MakeButton(strRemoveGameObjects, -1, worldUi.line);
			uiExposeBreasts = MakeButton(strExposeBreasts, 0, worldUi.line);
			uiExposeBreastsStrong = MakeButton(strExposeBreastsStrong, 1, worldUi.line);
			uiPullUpSkirt = MakeButton(strPullUpSkirt, 2, worldUi.line);
			uiRemoveGameObjects.button.onClick.AddListener(OnRemoveGameObjectsClick);
			uiExposeBreasts.button.onClick.AddListener(OnExposeBreastsClick);
			uiExposeBreastsStrong.button.onClick.AddListener(OnExposeBreastsStrongClick);
			uiPullUpSkirt.button.onClick.AddListener(OnPullUpSkirtClick);
			worldUi.line++;
		}

		public void MakeMenuBodyPartAddon1TakeControl(){
			uiReturnControlOfPlugin = MakeButton(strReturnControlOfPlugin, -1, worldUi.line);
			uiTakeControlOfPlugin = MakeButton(strTakeControlOfPlugin, 0, worldUi.line);
			if(!core.GetMemoryBool("isCompact")){
				uiHint1 = MakeButton(strHint1, 1, worldUi.line);
				worldUi.ColoringButton(uiHint1, 0f, 0f, 0f);
			}
			uiTakeControlOfPlugin.button.onClick.AddListener(OnTakeControlOfPluginsClick);
			uiReturnControlOfPlugin.button.onClick.AddListener(OnReturnControlOfPluginsClick);
			if(!core.GetMemoryBool("isCompact")){
				uiHint1.button.onClick.AddListener(OnHint1Click);
				uiHint12.button.onClick.AddListener(OnHint12Click);				
			}
			worldUi.line++;

		}
		
		public void OnExpandAddon1ValueOnly(){OnExpandCommonValueOnly("Addon1");}
		public void OnCollapseAddon1ValueOnly(){OnCollapseCommonValueOnly("Addon1");}
		
		public void OnExpandCommonValueOnly(string type){
			if(type == "Addon1"){
				core.SetMemoryBool("Addon1", true);
			}
		}
		
		public void OnCollapseCommonValueOnly(string type){
			if(type == "Addon1"){
				core.SetMemoryBool("Addon1", false);
			}
		}
		
		public void OnExpandAddon1(){OnExpandCommon("Addon1");}
		public void OnCollapseAddon1(){OnCollapseCommon("Addon1");}

		public void OnExpandCommon(string type){
			if(type == "Addon1"){
				core.SetMemoryBool("Addon1", true);
			}
			worldUi.RemoveMenuBody();
			worldUi.MakeMenuBody();
		}
		
		public void OnCollapseCommon(string type){
			if(type == "Addon1"){
				core.SetMemoryBool("Addon1", false);
			}
			worldUi.RemoveMenuBody();
			worldUi.MakeMenuBody();
		}
		
		public void LabelSwitch(){
			LabelVarChange();
			LabelUpdate();
		}
				
		public void LabelVarChange(){
			strUndressOpt1Var = (core.addonManager1.holdNGWordsOnGlobal ) ? strUndressOpt1On : strUndressOpt1Off;
			strUndressOpt2Var = (core.addonManager1.holdClothSimOnGlobal) ? strUndressOpt2On : strUndressOpt2Off;
			strUndressOpt3Var = (core.addonManager1.holdSkinWrapOnGlobal) ? strUndressOpt3On : strUndressOpt3Off;
			strUndressOpt4Var = (core.addonManager1.wrapAlterToSimOnGlobal) ? strUndressOpt4On : strUndressOpt4Off;
			strUndressOpt5Var = (core.addonManager1.forcedUndressOnGlobal) ? strUndressOpt5On : strUndressOpt5Off;
			strUndressOpt6Var = (core.addonManager1.undressReverseOnGlobal) ? strUndressOpt6On : strUndressOpt6Off;
			strUndressOpt7Var = (core.addonManager1.undressDetachOnGlobal) ? strUndressOpt7On : strUndressOpt7Off;
		}
		
		public void LabelUpdate(){
			core.worldUi.LabelUpdateImpl(uiUndressOpt1, strUndressOpt1Var);
			core.worldUi.LabelUpdateImpl(uiUndressOpt2, strUndressOpt2Var);
			core.worldUi.LabelUpdateImpl(uiUndressOpt3, strUndressOpt3Var);
			core.worldUi.LabelUpdateImpl(uiUndressOpt4, strUndressOpt4Var);
			core.worldUi.LabelUpdateImpl(uiUndressOpt5, strUndressOpt5Var);
			core.worldUi.LabelUpdateImpl(uiUndressOpt6, strUndressOpt6Var);
			core.worldUi.LabelUpdateImpl(uiUndressOpt7, strUndressOpt7Var);
		}
		
		public void UndressPreparingCommon(){
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
			addonClothSim.SetRemoveOptions();
		}

		public void UndressPartialCommon(string tags){
			core.EmbarrassALittle();
			UndressPreparingCommon();
			core.DoDelayedAction(() => core.DoAddonManager2Function("CoveringTargetsForUndress"), 1.5f);
			addonClothSim.Undress(core.addonManager1.undressPower, core.addonManager1.undressSeconds, false, false, core.addonManager1.undressDetachOnGlobal, tags);
		}

		public void OnUndressOverallClick(){
			UndressPartialCommon("");
		}

		public void OnUndressOutfitClick(){
			UndressPartialCommon("shirt,sweater,dress,bodysuit,shorts,skirt,pants");
		}

		public void OnUndressUnderwearClick(){
			UndressPartialCommon("bra,panties");
		}

		public void OnUndressMiscClick(){
			UndressPartialCommon("hat,jewely,accessory,glasses,jewely,gloves,stockings,socks,shoes,underwear");
		}
		
		public void OnAltSkinWrapClick(){
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
			addonClothSim.AlterSkinWrap();
		}
		
		public void OnUndressRecoverClick(){
			addonClothSim.RemoveResetClothes();
			addonClothSim.RecoverClothesState();
			addonClothSim.WrapNormal();
			addonClothSim.ResetClothesState();
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
		}

		public void OnRemoveGameObjectsClick(){
			core.RemoveGameObjectByName("clothGrabber");
			core.customUnityAssetItem.suffixCount = 0;
		}

		public void OnExposeBreastsClick(){
			addonClothSim.ChangeClothes();
			core.customUnityAssetItem.MakeShirtSpreaders();;
		}

		public void OnExposeBreastsStrongClick(){
			addonClothSim.ChangeClothes();
			core.customUnityAssetItem.MakeShirtSpreaders(strStrengthType:"high");;
		}

		public void OnPullUpSkirtClick(){
			core.customUnityAssetItem.MakePullingSkirtUppers();
		}
		
		public void OnUndressRemoveClick(){
			addonClothSim.RecoverClothesState();
			addonClothSim.BackupClothesState();
			addonClothSim.SetRemoveOptions();
			addonClothSim.RemoveClothes();
		}

		public void OnUndressOpt1Click(){
			core.customUi.ToggleExternal("Hold Clothes containing NGWords");
			core.worldUi.LabelSwitch();
		}

		public void OnUndressOpt2Click(){
			core.customUi.ToggleExternal("Hold Clothes with ClothSim");
			core.worldUi.LabelSwitch();
		}

		public void OnUndressOpt3Click(){
			core.customUi.ToggleExternal("Hold Clothes with AlterSkinWrap");
			core.worldUi.LabelSwitch();
		}

		public void OnUndressOpt4Click(){
			core.customUi.ToggleExternal("Alter SkinWrap to ClothSim");
			core.worldUi.LabelSwitch();
		}

		public void OnUndressOpt5Click(){
			core.customUi.ToggleExternal("Forced Undress");
			core.worldUi.LabelSwitch();
		}

		public void OnUndressOpt6Click(){
			core.customUi.ToggleExternal("Reverse Gravity");
			core.worldUi.LabelSwitch();
		}

		public void OnUndressOpt7Click(){
			core.customUi.ToggleExternal("Undress Detach");
			core.worldUi.LabelSwitch();
		}

		public void OnTakeControlOfPluginsClick(){
			addonTakeControl.TakeControlOfPlugins();
			addonTakeControl.TakeControlOfEverythingButPlugins();
		}

		public void OnHint1Click(){
			core.hint.StopOtherPluginsHint();
		}

		public void OnHint12Click(){
			core.hint.RemoveOptionsHint();
		}

		public void OnHint13Click(){
			core.hint.UndressPartialHint();
		}

		public void OnReturnControlOfPluginsClick(){
			addonTakeControl.ReturnControlOfPlugins();
			addonTakeControl.ReturnControlOfEverythingButPlugins();
		}
		

		public UIDynamicButton MakeButton(string name, int x, int y, float width = 0f, float height = 0f){
			return worldUi.MakeButtonForAddon(name, x, y, width, height);
		}

		public UIDynamicButton MakeButton(string name, float x, int y, float width = 0f, float height = 0f, bool isMinimizeButton = false, bool isMinisizeButton = false){
			return worldUi.MakeButton(name, x, y, width, height, isMinimizeButton, isMinisizeButton);
		}
		public UIDynamicTextField MakeTextField(string text, int x, int y, float width = 0f, float height = 0f){
			return worldUi.MakeTextFieldForAddon(text, x, y, width, height);
		}

		public UIDynamicSlider MakeSlider(string name, int x, int y, float min, float max, float current){
			return worldUi.MakeSlider(name, x, y, min, max, current);
		}
	}
}